##
# A namespace for Internal types.
module Rsrb::Internal::Types
  ##
  # A self-executing object.
  class Routine
    include Rsrb::Internal::Utils

    ##
    # Called when a new Routine is created.
    def initialize(assets)
      init_loggers
      @assets = assets
      execute
      successful
    rescue StandardError => e
      err! 'An error occurred while executing the routine!', e
      unsuccessful
    end

    ##
    # The execution function for this routine
    def execute; end

    ##
    # The callback function for this routine
    def successful; end

    ##
    # The errback function for this routine.
    def unsuccessful; end
  end
end